var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));

// src/index.ts
var transformSearchQueryEvent = (event) => {
  var _a;
  const transformFilterValues = (values) => {
    const transformBasicValue = (value) => value.toString();
    const transformRangeValue = (value) => `${value.from || "*"}-${value.to || "*"}`;
    return values.reduce((res, value) => {
      if (Array.isArray(value)) {
        return [...res, ...value.map(transformBasicValue)];
      }
      return [
        ...res,
        typeof value === "object" ? transformRangeValue(value) : transformBasicValue(value)
      ];
    }, []);
  };
  return {
    search: {
      query: event.query,
      filters: event.filters.reduce(
        (res, filter) => __spreadProps(__spreadValues({}, res), {
          [filter.field]: transformFilterValues(filter.values)
        }),
        {}
      ),
      page: {
        current: event.currentPage,
        size: event.resultsPerPage
      },
      results: {
        items: [],
        total_results: event.totalResults
      },
      sort: (_a = event.sort) == null ? void 0 : _a.filter(
        (sort) => sort.direction === "desc" || sort.direction === "asc"
      ).map((sort) => ({
        name: sort.field,
        direction: sort.direction
      }))
    }
  };
};
var mapEventToTrackerParams = {
  ResultSelected: (event) => [
    "search_click",
    __spreadProps(__spreadValues({}, transformSearchQueryEvent(event)), {
      document: { id: event.documentId, index: event.origin }
    })
  ],
  SearchQuery: (event) => [
    "search",
    transformSearchQueryEvent(event)
  ]
};
function AnalyticsPlugin(options = { client: void 0 }) {
  console.warn(
    "WARNING: The AnalyticsPlugin is deprecated and will be removed in future versions."
  );
  const client = options.client || typeof window !== "undefined" && window["elasticAnalytics"];
  if (!client) {
    throw new Error(
      "Analytics client not found. Please provide a client or install the Elastic Analytics library."
    );
  }
  return {
    subscribe: (event) => {
      var _a;
      const [eventType, payload] = ((_a = mapEventToTrackerParams[event.type]) == null ? void 0 : _a.call(mapEventToTrackerParams, event)) || [];
      if (!eventType || !payload) {
        return;
      }
      client.trackEvent(eventType, payload);
    }
  };
}
export {
  AnalyticsPlugin as default
};
//# sourceMappingURL=index.mjs.map